// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#include "stdafx.h"
#include "Convert.h"

CString Ole2Utf8(LPOLESTR _pStr)
{
	if (!_pStr)
		return NULL;
	CString rez;
	unsigned int len = WideCharToMultiByte(CP_UTF8, 0, _pStr, (unsigned int)wcslen(_pStr)+1, 0, 0, NULL, NULL);
	WideCharToMultiByte(CP_UTF8, 0, _pStr, (unsigned int)wcslen(_pStr)+1, rez.GetBuffer(len), len, NULL, NULL);
	rez.ReleaseBuffer();
	return rez;
}

CComBSTR Utf82Ole(LPCSTR _pStr)
{
	if (!_pStr)
		return NULL;
	int len = MultiByteToWideChar(CP_UTF8, 0, _pStr, -1, NULL, 0);
	ATLASSERT(len != 0);
	if (!len)
		return NULL;
	LPWSTR wsBuff = (LPWSTR)malloc(len * sizeof(WCHAR));
	len = MultiByteToWideChar(CP_UTF8, 0, _pStr, -1, wsBuff, len);
	ATLASSERT(len != 0);
	if (!len)
		return NULL;
	CComBSTR rez(wsBuff);
	free(wsBuff);
	return rez;
}

CString Utf82Ansi(LPCSTR _pStr)
{
	if (!_pStr)
		return NULL;
	CString rez;
	unsigned int len = MultiByteToWideChar(CP_UTF8, 0, _pStr, (unsigned int)strlen(_pStr)+1, 0, 0);
	WCHAR *outp = (WCHAR *)malloc(len*sizeof(WCHAR));
	MultiByteToWideChar(CP_UTF8, 0, _pStr, (unsigned int)strlen(_pStr)+1, outp, len);
	unsigned int len1 = WideCharToMultiByte(CP_ACP, 0, outp, len, 0, 0, NULL, NULL);
	WideCharToMultiByte(CP_ACP, 0, outp, len, rez.GetBuffer(len1), len1, NULL, NULL);
	rez.ReleaseBuffer();
	free(outp);
	return rez;
}

CString Ansi2Utf8(LPCSTR _pStr)
{
	if (!_pStr)
		return NULL;
	CString rez;
	unsigned int len = MultiByteToWideChar(CP_ACP, 0, _pStr, (unsigned int)strlen(_pStr)+1, 0, 0);
	WCHAR *outp = (WCHAR *)malloc(len*sizeof(WCHAR));
	MultiByteToWideChar(CP_ACP, 0, _pStr, (unsigned int)strlen(_pStr)+1, outp, len);
	unsigned int len1 = WideCharToMultiByte(CP_UTF8, 0, outp, len, 0, 0, NULL, NULL);
	WideCharToMultiByte(CP_UTF8, 0, outp, len, rez.GetBuffer(len1), len1, NULL, NULL);
	rez.ReleaseBuffer();
	free(outp);
	return rez;
}

CString Ole2Ansi(LPOLESTR _pStr)
{
	if (!_pStr)
		return NULL;
	CString rez;
	unsigned int len = WideCharToMultiByte(CP_ACP, 0, _pStr, (unsigned int)wcslen(_pStr)+1, 0, 0, NULL, NULL);
	WideCharToMultiByte(CP_ACP, 0, _pStr, (unsigned int)wcslen(_pStr)+1, rez.GetBuffer(len), len, NULL, NULL);
	rez.ReleaseBuffer();
	return rez;
}

CComBSTR Ansi2Ole(LPCSTR _pStr, int iLen)
{
	if (!_pStr)
		return NULL;
	unsigned int len = MultiByteToWideChar(CP_ACP, 0, _pStr, iLen, 0, 0);
	BSTR bsBuff =(BSTR)malloc(len*sizeof(BSTR));
	MultiByteToWideChar(CP_ACP, 0, _pStr, iLen, (BSTR)bsBuff, len);
	CComBSTR rez(len, bsBuff);
	free(bsBuff);
	return rez;
}

CString Ole2Uri(LPOLESTR _pStr, apr_pool_t *pool)
{
	CString rez = Ole2Utf8(_pStr);
	rez.Replace("\\", "/");
	if (svn_path_is_url (rez) && rez.Find("%")==-1)
		rez = svn_path_uri_encode(rez, pool);
	return rez;
}

CComBSTR Uri2Ole(LPCSTR _pStr, apr_pool_t *pool)
{
	if (!_pStr)
		return NULL;
	return Utf82Ole(svn_path_uri_decode(_pStr, pool));
}
