// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#include "stdafx.h"
#include "SVNAuthManager.h"
#include "svnauthmanager.h"
#include "Convert.h"
#include "LoginDlg.h"

STDMETHODIMP  CSVNAuthManager::AskEvent(SVNAuthProviderAsk nAsk, ISVNAuthProvider* pProvider)
{
	CComQIPtr<ISVNAuthProvider> oProvider(pProvider);
	CComBSTR bstrRealM;
	oProvider->get_RealM(&bstrRealM);
	CLoginDlg Dlg;
	Dlg.m_nAsk = nAsk;
	LONG dwCookie;
	oProvider->get_Cookie(&dwCookie);
	Dlg.m_sRealm.Format("%s -=%d=-",Ole2Ansi(bstrRealM),dwCookie);
	VARIANT_BOOL bMaySave;
	oProvider->get_MaySave(&bMaySave);
	Dlg.m_bMaySave = bMaySave==VARIANT_TRUE;

	switch (nAsk)
	{
	case SVNAuthProviderAskUser: {
		Dlg.m_sDlgName = "Please type your login (username)";
		Dlg.m_sUserText = "Username :";
		CComBSTR bstrUser;
		oProvider->get_DefUserName(&bstrUser);
		Dlg.m_sUserName = Ole2Ansi(bstrUser);
		CComBSTR bstrPassword;
		oProvider->get_DefPassword(&bstrPassword);
		Dlg.m_sPassword = Ole2Ansi(bstrPassword);
		Dlg.DoModal();
		oProvider->put_DefPassword(Ansi2Ole(Dlg.m_sUserName));
		break;
	}
	case SVNAuthProviderAskPassword: {
		Dlg.m_sDlgName = "Please type your password";
		Dlg.m_sUserText = "Username :";
		Dlg.m_sPsswText = "Password :";
		CComBSTR bstrUser;
		oProvider->get_DefUserName(&bstrUser);
		Dlg.m_sUserName = Ole2Ansi(bstrUser);
		CComBSTR bstrPassword;
		oProvider->get_DefPassword(&bstrPassword);
		Dlg.m_sPassword = Ole2Ansi(bstrPassword);
		Dlg.DoModal();
		oProvider->put_DefPassword(Ansi2Ole(Dlg.m_sPassword));
		break;
	}
	case SVNAuthProviderAskUserAndPassword: {
		Dlg.m_sDlgName = "Please type user name (login) and password";
		Dlg.m_sUserText = "Username :";
		Dlg.m_sPsswText = "Password :";
		CComBSTR bstrUser;
		oProvider->get_DefUserName(&bstrUser);
		Dlg.m_sUserName = Ole2Ansi(bstrUser);
		CComBSTR bstrPassword;
		oProvider->get_DefPassword(&bstrPassword);
		Dlg.m_sPassword = Ole2Ansi(bstrPassword);
		Dlg.DoModal();
		oProvider->put_DefUserName(Ansi2Ole(Dlg.m_sUserName));
		oProvider->put_DefPassword(Ansi2Ole(Dlg.m_sPassword));
		break;
	}
	case SVNAuthProviderAskSslServerTrust: {
		LONG lChoice = 0;
		switch(MessageBox(NULL, Ole2Ansi(bstrRealM), "Warning!", Dlg.m_bMaySave?MB_YESNOCANCEL:MB_OKCANCEL | MB_ICONWARNING))
		{
		case(IDYES):
		case(IDOK):
			lChoice = 1;
			break;
		case(IDNO):
			lChoice = 2;
			break;
		}
		oProvider->put_Choice(lChoice);
		break;}
	case SVNAuthProviderAskSslClientCert: {
		Dlg.m_sDlgName = "Please enter your Sertificate file name.";
		Dlg.m_sUserText = "File name :";
		Dlg.DoModal();
		Dlg.m_sUserName.Replace('\\', '/');
		oProvider->put_CertFileName(Ansi2Ole(Dlg.m_sUserName));
		break;}
	case SVNAuthProviderAskSslClientCertPw: {
		Dlg.m_sDlgName = "Please enter Passphrase.";
		Dlg.m_sPsswText = "Passphrase :";
		Dlg.DoModal();
		oProvider->put_DefPassword(Ansi2Ole(Dlg.m_sPassword));
		break;}
	default :
		return S_OK;
	}

	oProvider->put_MaySave(Dlg.m_bMaySave?VARIANT_TRUE:VARIANT_FALSE);

	return S_OK;
}

// CSVNAuthManager
STDMETHODIMP CSVNAuthManager::CreateAuthProvider(ISVNAuthProvider** pProvider, LONG* pdwCookie)
{
	if (!pProvider|| !pdwCookie) return E_POINTER;
	CComPtr <ISVNAuthProvider> oProvider;
	HRESULT hr = oProvider.CoCreateInstance(__uuidof(SVNAuthProvider));
	if (FAILED(hr)) return hr;
	Lock();
	DWORD dwCookie = m_arr.Add(oProvider);
	Unlock();
	if (dwCookie)
	{
		hr = oProvider.CopyTo(pProvider);
		if (!FAILED(hr))
		{
			*pdwCookie = dwCookie;
			hr = oProvider->Init();
			if (!FAILED(hr))
			{
				DWORD dwSinkCookie;
				hr = AtlAdvise(oProvider, GetUnknown(), IID__ISVNAuthProviderEvents,&dwSinkCookie);
				if (!FAILED(hr))
				{
					Lock();
					m_mapSinkCookies[dwCookie] = dwSinkCookie;
					m_mapUsage[dwCookie]=1;
					Unlock();
					oProvider->put_Cookie(dwCookie);
					oProvider.Detach();
					return S_OK;
				}
			}
		}
		if (FAILED(hr))
		{
			Lock();
			m_arr.Remove(dwCookie);
			Unlock();
			return hr;
		}
	}
	return E_FAIL;
}

STDMETHODIMP CSVNAuthManager::RetrieveAuthProvider(LONG dwCookie, ISVNAuthProvider** ppProvider)
{
	Lock();
	if (m_mapUsage.count(dwCookie))
	{
		IUnknown *pUnk = m_arr.GetUnknown(dwCookie);
		ATLASSERT(pUnk);
		m_mapUsage[dwCookie]++;
		CComQIPtr<ISVNAuthProvider> oProvider(pUnk);
		Unlock();
		return oProvider.CopyTo(ppProvider);
	}
	else 
	{
		Unlock();
		return E_INVALIDARG;
	}
}

STDMETHODIMP CSVNAuthManager::AddRefAuthProvider(LONG dwCookie)
{
	Lock();
	if (m_mapUsage.count(dwCookie))
	{
		m_mapUsage[dwCookie]++;
		Unlock();
		return S_OK;
	}
	Unlock();
	return E_INVALIDARG;
}

STDMETHODIMP CSVNAuthManager::ReleaseAuthProvider(LONG dwCookie)
{
	Lock();
	if (m_mapUsage.count(dwCookie))
	{
		m_mapUsage[dwCookie]--;
		LONG dwRefCount = m_mapUsage[dwCookie];
		if (dwRefCount<=0)
		{
			IUnknown *pUnk = m_arr.GetUnknown(dwCookie);
			AtlUnadvise(pUnk,IID__ISVNAuthProviderEvents, m_mapSinkCookies[dwCookie]);
			pUnk->Release();
			m_arr.Remove(dwCookie);
			m_mapUsage.erase(dwCookie);
			m_mapSinkCookies.erase(dwCookie);
		}
		Unlock();
		return S_OK;
	}
	Unlock();
	return E_INVALIDARG;
}

STDMETHODIMP CSVNAuthManager::RevokeAuthProvider(LONG dwCookie)
{
	Lock();
	if (m_mapUsage.count(dwCookie))
	{
		IUnknown *pUnk = m_arr.GetUnknown(dwCookie);
		pUnk->Release();
		m_arr.Remove(dwCookie);
		m_mapUsage.erase(dwCookie);
	}
	Unlock();
	return S_OK;
}

