// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "oledb.h"       

#include "svn_client.h"

#include "pcom.h"
#include "_ISVNClientEvents_CP.h"


// CSVNClient

class ATL_NO_VTABLE CSVNClient : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNClient, &CLSID_SVNClient>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CSVNClient>,
	public CProxy_ISVNClientEvents<CSVNClient>, 
//	public IDispatchImpl<ISVNClient, &IID_ISVNClient, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>,
//	public IDispatchImpl<ISVNClient2, &IID_ISVNClient2, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>,
//	public IDispatchImpl<ISVNClient3, &IID_ISVNClient3, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>,
//	public IDispatchImpl<ISVNClient4, &IID_ISVNClient4, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IDispatchImpl<ISVNClient5, &IID_ISVNClient5, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IDispatchImpl<_ISVNClient, &IID__ISVNClient, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNClient()
	{
		// default values goes here
		m_bInitialized = false;
		m_bAuthInteractiveOnly = false;
		m_bAuthNonInteractive = false;
		m_bGitEvents = true;
		m_dwAuthCookie = 0;
		m_bAuthExternal = false;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNCLIENT)


BEGIN_COM_MAP(CSVNClient)
	COM_INTERFACE_ENTRY(_ISVNClient)
	COM_INTERFACE_ENTRY(ISVNClient)
	COM_INTERFACE_ENTRY(ISVNClient2)
	COM_INTERFACE_ENTRY(ISVNClient3)
	COM_INTERFACE_ENTRY(ISVNClient4)
	COM_INTERFACE_ENTRY(ISVNClient5)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CSVNClient)
	CONNECTION_POINT_ENTRY(__uuidof(_ISVNClientEvents))
END_CONNECTION_POINT_MAP()
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	DECLARE_GET_CONTROLLING_UNKNOWN()

		HRESULT FinalConstruct()
		{
			return CoCreateFreeThreadedMarshaler(
				GetControllingUnknown(), &m_pUnkMarshaler.p);
		}

		void FinalRelease()
		{
			if (m_dwAuthCookie)
			{
				CComPtr<ISVNAuthManager> oAuth;
				oAuth.CoCreateInstance(__uuidof(SVNAuthManager));
				oAuth->ReleaseAuthProvider(m_dwAuthCookie);
				m_oAuthProvider.Release();
			}
			m_pUnkMarshaler.Release();
		}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(IsCancelRequested)(LONG* bValue) {
		if (!bValue) return E_POINTER;
		*bValue = m_bCancelRequested;
		return S_OK;
	}
	STDMETHOD(FireIdle)(void) {
		Fire_Idle(this);
		return S_OK;
	}
	STDMETHOD(FireWcNotify)(ISVNWcNotify *pVal) {
		Fire_WcNotify(pVal);
		return S_OK;
	}
	STDMETHOD(FireWcProgress)(long progress, long total) {
		Fire_WcProgress(progress, total);
		return S_OK;
	}

public:
	struct ClientNotifyBaton {
		_ISVNClient*		oClient;
		ISVNWcNotifyVector*	oNotifyVector;
	};
	bool				m_bGitEvents;		// wether raised event appart safe or not
private:
	CComPtr<ISVNAuthProvider> m_oAuthProvider;
	LONG				m_dwAuthCookie;
	ClientNotifyBaton	m_oClientNotifyBaton;
	bool				m_bInitialized;
	bool				m_bCancelRequested;
	bool				m_bAuthExternal;
	CString				m_sOptConfigDir;
	CString				m_sDefUserName;
	CString				m_sDefPassword;
	bool				m_bAuthInteractiveOnly;
	bool				m_bAuthNonInteractive;
	apr_pool_t			*m_pPool;				// main client memory pool
	svn_client_ctx_t	*m_pCtx;					// main client context
public:
	STDMETHOD(AddFiles)(IStringVector* arStrings, VARIANT_BOOL bRecurse, VARIANT_BOOL bForce, VARIANT_BOOL bNoIgnore, ISVNWcNotifyVector** ppStatus);
	// GetFiles - "update" subcommand in comand line client
	STDMETHOD(GetFiles)(IStringVector* arStrings, BSTR sRev, VARIANT_BOOL bRecurse, VARIANT_BOOL bIgnoreExternals, ISVNWcNotifyVector** ppStatus);
	STDMETHOD(InitClient)(void);
	STDMETHOD(GetStatus)(BSTR sPath, VARIANT_BOOL bRecurse, BSTR sRev, VARIANT_BOOL bGetAll, VARIANT_BOOL bUpdate, VARIANT_BOOL bNoIgnore, VARIANT_BOOL bIgnoreExternals, ISVNWcStatusInfo **ppFiles);
	STDMETHOD(List)(BSTR sPath, BSTR sPRevision, BSTR sRevision, VARIANT_BOOL bRecurse, IStringVector** arStrings);
	STDMETHOD(LockFiles)(IStringVector* arStrings, BSTR sComment, VARIANT_BOOL bStealLock);
	STDMETHOD(UnLockFiles)(IStringVector* arStrings, VARIANT_BOOL bStealLock);
	STDMETHOD(Revert)(IStringVector* arStrings, VARIANT_BOOL bRecursive);
	STDMETHOD(Delete)(IStringVector* arStrings, BSTR sComment, VARIANT_BOOL bForce);
	STDMETHOD(MkDir)(IStringVector* arStrings, BSTR sComment);
	STDMETHOD(CleanUp)(IStringVector* arStrings);
	STDMETHOD(Move)(IStringVector* arFilesSrc, IStringVector* arFilesDst, VARIANT_BOOL bForce, BSTR sComment);
	STDMETHOD(Resolved)(IStringVector* arStrings, VARIANT_BOOL bRecursive);
	STDMETHOD(Commit)(IStringVector* arStrings, BSTR sComment, VARIANT_BOOL bRecursive, VARIANT_BOOL bKeepLock);
	STDMETHOD(Copy)(IStringVector* arFilesSrc, IStringVector* arFilesDst, BSTR sComment, BSTR sStartRevision);
	STDMETHOD(CheckOut)(IStringVector* arStrings, BSTR sPegRevision, BSTR sStartRevision, VARIANT_BOOL bRecursive, VARIANT_BOOL bIgnoreExternals);
	STDMETHOD(RaCheckUrlValid)(BSTR sUrl, BSTR sRev);
	STDMETHOD(WcRestoreFiles)(IStringVector* arStrings, VARIANT_BOOL bUseCommitTimes);
	STDMETHOD(_SetupAuth)(LONG	nCookie,	LONG * ppCookie	);
	STDMETHOD(SetupAuth)(LONG	nCookie,	LONG * ppCookie	);
	STDMETHOD(Log)(IStringVector* arStrings, BSTR sStartRev, BSTR sEndRev, LONG lLimit, VARIANT_BOOL bVerbose, VARIANT_BOOL bStopOnCopy, ISVNWcLogVector** arLogs);
	STDMETHOD(Info)(IStringVector* arStrings, BSTR sPegRev, BSTR sStartRev, VARIANT_BOOL bRecursiv, ISVNWcInfoVector** arInfo);
	STDMETHOD(PropGet)(BSTR sFile, BSTR sPropName, BSTR PegRev, BSTR sStartRev, VARIANT_BOOL bRecursiv, BSTR * sVal);
	STDMETHOD(PropSet)(BSTR sFile, BSTR sPropName, BSTR sVal, VARIANT_BOOL bRecursiv, VARIANT_BOOL bForce);
	STDMETHOD(PropDel)(BSTR sFile, BSTR sPropName, VARIANT_BOOL bRecursiv);
	STDMETHOD(PropList)(BSTR sFile, BSTR sPegRev, BSTR sStartRev, VARIANT_BOOL bRecursiv, ISVNWcPropListVector** arStrings);
	STDMETHOD(Version)(LONG *nComSvnVersion, LONG *nSvnVersion, BSTR *sVal);
	STDMETHOD(Annotate)(BSTR sFile, BSTR sPegRev, BSTR sStartRev, BSTR sEndRev, ISVNWcAnnVector** arAnns);
	STDMETHOD(Cat)(BSTR sFile, BSTR sPegRev, BSTR sStartRev, BSTR* sVal);
	STDMETHOD(RequestCancelation)() {
		m_bCancelRequested = true;
		return S_OK;
	}
	STDMETHOD(ExportFiles)(IStringVector* arFilesSrc, IStringVector* arFilesDst, BSTR sPRevision, BSTR sRevision, VARIANT_BOOL bRecurse, VARIANT_BOOL bOverwrite, VARIANT_BOOL bIgnoreExternals);
	STDMETHOD(ImportFiles)(IStringVector *arFilesSrc, IStringVector *arFilesDst, BSTR sComment, VARIANT_BOOL bNonRecursive, VARIANT_BOOL bNoIgnore);
	STDMETHOD(Relocate)(BSTR sPath, BSTR sFrom, BSTR sTo, VARIANT_BOOL bRecursive);
	STDMETHOD(Diff)(BSTR arOptions, BSTR sPath1, BSTR sRevision1, BSTR sPath2, BSTR sRevision2,
				BSTR sOutFile, BSTR sErrFile, BSTR sHeaderEncoding,
				VARIANT_BOOL bRecursive, VARIANT_BOOL bIgnoreAncestry, VARIANT_BOOL bNoDiffDeleted, VARIANT_BOOL bIgnoreContentType);
	STDMETHOD(DiffPeg)(BSTR sOptions, BSTR sPath, BSTR sPegRevision, BSTR sStartRevision, BSTR sEndRevision,
				BSTR sOutFile, BSTR sErrFile, BSTR sHeaderEncoding,
				VARIANT_BOOL bRecursive, VARIANT_BOOL bIgnoreAncestry, VARIANT_BOOL bNoDiffDeleted, VARIANT_BOOL bIgnoreContentType);
	STDMETHOD(Merge)(BSTR sPath1, BSTR sRevision1, BSTR sPath2, BSTR sRevision2, BSTR sTargetWCPath,
				VARIANT_BOOL bRecursive, VARIANT_BOOL bIgnoreAncestry, VARIANT_BOOL bForce, VARIANT_BOOL bDryRun);
	STDMETHOD(MergePeg)(BSTR sSource, BSTR sPegRevision, BSTR sStartRevision, BSTR sEndRevision, BSTR sTargetWCPath,
				VARIANT_BOOL bRecursive, VARIANT_BOOL bIgnoreAncestry, VARIANT_BOOL bForce, VARIANT_BOOL bDryRun);
	STDMETHOD(SetOption)(SvnClientOption eOption, VARIANT vVal);
	STDMETHOD(GetOption)(SvnClientOption eOption, VARIANT *pVal);
	STDMETHOD(RevPropGet) (BSTR sUrl, BSTR sPropName, BSTR sRev, BSTR *sVal );
	STDMETHOD(RevPropSet) (BSTR sUrl, BSTR sPropName, BSTR sVal, BSTR sRev,  VARIANT_BOOL bForce);
	STDMETHOD(RevPropDel) (BSTR sUrl, BSTR sPropName, BSTR sRev);
	STDMETHOD(RevPropList)(BSTR sUrl, BSTR sRev, IStringVector **arListing);

	STDMETHOD(RaCheckUrlKind)(BSTR sUrl, BSTR sRev, SvnNodeKind *eKind);
	STDMETHOD(RaGetReposiotryRoot)(BSTR sPath, BSTR *sRoot);

	STDMETHOD(LinkWithParentFolder)(BSTR sPath);
	STDMETHOD(GetConflictRev)(BSTR sPath, BSTR *lOld, BSTR *lNew, BSTR *lWrk);
	STDMETHOD(GetSvnUrl)(BSTR sPath, BSTR *sUrl);

	STDMETHOD(SvnTimeToHumanString)(CY cyTime, BSTR *sTime);

	STDMETHOD(Switch)(BSTR bstrPath, BSTR bstrSwitchURL, BSTR bstrRevision, VARIANT_BOOL bRecursive);
};

OBJECT_ENTRY_AUTO(__uuidof(SVNClient), CSVNClient)




