// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#include "stdafx.h"
#include "SVNWcStatus.h"


// CSVNWcStatus

STDMETHODIMP CSVNWcStatus::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ISVNWcStatus,
		&IID_ISVNWcStatus2
	};

	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CSVNWcStatus::put_Entry(ISVNWcEntry* pVal)
{
	LOCK_THIS_OBJ
	entry = pVal;
	return S_OK;
}
STDMETHODIMP CSVNWcStatus::get_Entry(ISVNWcEntry** ppVal)
{
	LOCK_THIS_OBJ
	return entry.CopyTo(ppVal);
}


STDMETHODIMP CSVNWcStatus::put_TextStatus(SvnWcStatusKind Val)
{
	LOCK_THIS_OBJ
	text_status = Val;
	return S_OK;
}
STDMETHODIMP CSVNWcStatus::get_TextStatus(SvnWcStatusKind* pVal)
{
	if (!pVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pVal = text_status;
	return S_OK;
}


STDMETHODIMP CSVNWcStatus::put_PropStatus(SvnWcStatusKind Val)
{
	LOCK_THIS_OBJ
	prop_status = Val;
	return S_OK;
}
STDMETHODIMP CSVNWcStatus::get_PropStatus(SvnWcStatusKind* pVal)
{
	if (!pVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pVal = prop_status;
	return S_OK;
}


STDMETHODIMP CSVNWcStatus::put_Locked(BOOL blVal)
{
	LOCK_THIS_OBJ
	locked = blVal;
	return S_OK;
}
STDMETHODIMP CSVNWcStatus::get_Locked(BOOL* pblVal)
{
	if (!pblVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pblVal = locked;
	return S_OK;
}


STDMETHODIMP CSVNWcStatus::put_Copied(BOOL blVal)
{
	LOCK_THIS_OBJ
	copied = blVal;
	return S_OK;
}
STDMETHODIMP CSVNWcStatus::get_Copied(BOOL* pblVal)
{
	if (!pblVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pblVal = copied;
	return S_OK;
}


STDMETHODIMP CSVNWcStatus::put_Switched(BOOL blVal)
{
	LOCK_THIS_OBJ
	switched = blVal;
	return S_OK;
}
STDMETHODIMP CSVNWcStatus::get_Switched(BOOL* pblVal)
{
	if (!pblVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pblVal = switched;
	return S_OK;
}


STDMETHODIMP CSVNWcStatus::put_ReposTextStatus(SvnWcStatusKind Val)
{
	LOCK_THIS_OBJ
	repos_text_status = Val;
	return S_OK;
}
STDMETHODIMP CSVNWcStatus::get_ReposTextStatus(SvnWcStatusKind* pVal)
{
	if (!pVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pVal = repos_text_status;
	return S_OK;
}


STDMETHODIMP CSVNWcStatus::put_ReposPropStatus(SvnWcStatusKind Val)
{
	LOCK_THIS_OBJ
	repos_prop_status = Val;
	return S_OK;
}
STDMETHODIMP CSVNWcStatus::get_ReposPropStatus(SvnWcStatusKind* pVal)
{
	if (!pVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pVal = repos_prop_status;
	return S_OK;
}


STDMETHODIMP CSVNWcStatus::put_ReposLock(ISVNLock* pVal)
{
	LOCK_THIS_OBJ
	repos_lock = pVal;
	return S_OK;
}
STDMETHODIMP CSVNWcStatus::get_ReposLock(ISVNLock** ppVal)
{
	LOCK_THIS_OBJ
	return repos_lock.CopyTo(ppVal);
}

STDMETHODIMP CSVNWcStatus::get_URL(BSTR* pVal)
{
	LOCK_THIS_OBJ
	return url.CopyTo(pVal);
}

STDMETHODIMP CSVNWcStatus::put_URL(BSTR newVal)
{
	LOCK_THIS_OBJ
	url = newVal;
	return S_OK;
}

STDMETHODIMP CSVNWcStatus::get_LastCmtRev(LONG* pVal)
{
	if (!pVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pVal = last_cmt_rev;
	return S_OK;
}

STDMETHODIMP CSVNWcStatus::put_LastCmtRev(LONG newVal)
{
	LOCK_THIS_OBJ
	last_cmt_rev = newVal;
	return S_OK;
}

STDMETHODIMP CSVNWcStatus::get_LastCmtDate(CY* pVal)
{
	if (!pVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pVal = last_cmt_date;
	return S_OK;
}

STDMETHODIMP CSVNWcStatus::put_LastCmtDate(CY newVal)
{
	LOCK_THIS_OBJ
	last_cmt_date = newVal;
	return S_OK;
}

STDMETHODIMP CSVNWcStatus::get_LastCmtKind(SvnNodeKind* pVal)
{
	if (!pVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pVal = kind;
	return S_OK;
}

STDMETHODIMP CSVNWcStatus::put_LastCmtKind(SvnNodeKind newVal)
{
	LOCK_THIS_OBJ
	kind = newVal;
	return S_OK;
}

STDMETHODIMP CSVNWcStatus::get_LastCmdAuthor(BSTR* pVal)
{
	LOCK_THIS_OBJ
	return last_cmt_author.CopyTo(pVal);
}

STDMETHODIMP CSVNWcStatus::put_LastCmdAuthor(BSTR newVal)
{
	LOCK_THIS_OBJ
	last_cmt_author = newVal;
	return S_OK;
}
