// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once

#include "AppartSafeConnPoint.h"

template<class T>
class CProxy_ISVNClientEvents :
	public IAppartSafeConnectionPointImpl<T, &__uuidof(_ISVNClientEvents)>
{
public:
	HRESULT Fire_Idle( ISVNClient *  _pThis)
	{
		HRESULT hr = S_OK;
		T * pThis = static_cast<T *>(this);
		int cConnections = m_vec.GetSize();

		for (int iConnection = 0; iConnection < cConnections; iConnection++)
		{
			pThis->Lock();
			CComPtr<IUnknown> punkConnection;
			if (pThis->m_bGitEvents)
			{
				IUnknown *pUnk = m_vec.GetAt(iConnection);
				DWORD dwCookie = 0;
				if (pUnk != NULL)
					dwCookie = m_vec.GetCookie(&pUnk);
				if (m_mapCookie2GIT.count(dwCookie))
					m_AppartGit->GetInterfaceFromGlobal(m_mapCookie2GIT[dwCookie],__uuidof(_ISVNClientEvents),(void **)&punkConnection);
			}
			else
				punkConnection = m_vec.GetAt(iConnection);
			pThis->Unlock();

			IDispatch * pConnection = static_cast<IDispatch *>(punkConnection.p);

			if (pConnection)
			{
				CComVariant avarParams[1];
				avarParams[0] = pThis;
				CComVariant varResult;

				DISPPARAMS params = { avarParams, NULL, 1, 0 };
				hr = pConnection->Invoke(1, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &params, &varResult, NULL, NULL);
			}
		}
		return hr;
	}
	HRESULT Fire_WcNotify( ISVNWcNotify *  pSVNWcNotify)
	{
		HRESULT hr = S_OK;
		T * pThis = static_cast<T *>(this);
		int cConnections = m_vec.GetSize();

		for (int iConnection = 0; iConnection < cConnections; iConnection++)
		{
			pThis->Lock();
			CComPtr<IUnknown> punkConnection;
			if (pThis->m_bGitEvents)
			{
				IUnknown *pUnk = m_vec.GetAt(iConnection);
				DWORD dwCookie = 0;
				if (pUnk != NULL)
					dwCookie = m_vec.GetCookie(&pUnk);
				if (m_mapCookie2GIT.count(dwCookie))
					m_AppartGit->GetInterfaceFromGlobal(m_mapCookie2GIT[dwCookie],__uuidof(_ISVNClientEvents),(void **)&punkConnection);
			}
			else
				punkConnection = m_vec.GetAt(iConnection);
			pThis->Unlock();

			IDispatch * pConnection = static_cast<IDispatch *>(punkConnection.p);

			if (pConnection)
			{
				CComVariant avarParams[1];
				avarParams[0] = pSVNWcNotify;
				CComVariant varResult;

				DISPPARAMS params = { avarParams, NULL, 1, 0 };
				hr = pConnection->Invoke(2, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &params, &varResult, NULL, NULL);
			}
		}
		return hr;
	}
	HRESULT Fire_WcProgress(long progress, long total)
	{
		HRESULT hr = S_OK;
		T * pThis = static_cast<T *>(this);
		int cConnections = m_vec.GetSize();

		for (int iConnection = 0; iConnection < cConnections; iConnection++)
		{
			pThis->Lock();
			CComPtr<IUnknown> punkConnection;
			if (pThis->m_bGitEvents)
			{
				IUnknown *pUnk = m_vec.GetAt(iConnection);
				DWORD dwCookie = m_vec.GetCookie(&pUnk);
				if (m_mapCookie2GIT.count(dwCookie))
					m_AppartGit->GetInterfaceFromGlobal(m_mapCookie2GIT[dwCookie],__uuidof(_ISVNClientEvents),(void **)&punkConnection);
			}
			else
				punkConnection = m_vec.GetAt(iConnection);
			pThis->Unlock();

			IDispatch * pConnection = static_cast<IDispatch *>(punkConnection.p);

			if (pConnection)
			{
				CComVariant avarParams[2];
				avarParams[1] = progress;
				avarParams[0] = total;
				CComVariant varResult;

				DISPPARAMS params = { avarParams, NULL, 2, 0 };
				hr = pConnection->Invoke(3, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_METHOD, &params, &varResult, NULL, NULL);
			}
		}
		return hr;
	}
};


